/******************************************************************************
 SymCode.h

		Symbol code manager interface for the SignWriter key editor
		
		Copyright  1996 Center for Sutton Movement Writing. All rights reserved.

 ******************************************************************************/
 
#pragma once




		// SignWriter symbol codes (machine independent)
		
		
#define	 SYM_SIZE	5
#define	 CTL_SIZE   2
#define	 TXT_SIZE	3

		
typedef  Byte  SymCode [SYM_SIZE];			// symbol code

typedef	 Byte  CtrlCode[CTL_SIZE];			// control code

typedef	 Byte  TextBlk [TXT_SIZE];			// text block code

		


		// Symbol code fields		
	   				  

void  NewSymCode (Byte *base);							// init sym code

void  GetSymNum  (Byte *base, short *numVal);			// symbol number		  
void  SetSymNum  (Byte *base, short  numVal);			

void  GetSymVar  (Byte *base, short *varVal);			// symbol variation		  
void  SetSymVar  (Byte *base, short  varVal);			

void  GetSymFill (Byte *base, short *fillVal);			// symbol fill 		  
void  SetSymFill (Byte *base, short  fillVal);			

void  GetSymRot  (Byte *base, short *rotVal);			// symbol rotation		  
void  SetSymRot  (Byte *base, short  rotVal);			

void  GetSymFlop (Byte *base, short *flopVal);			// symbol flop			  
void  SetSymFlop (Byte *base, short  flopVal);	

void  GetSymMark (Byte *base, short *markVal);			// symbol mark		  
void  SetSymMark (Byte *base, short  markVal);	

void  GetSymXPos (Byte *base, short *xPosVal);			// symbol X position	  
void  SetSymXPos (Byte *base, short  xPosVal);	

void  GetSymYPos (Byte *base, short *yPosVal);			// symbol Y position			  
void  SetSymYPos (Byte *base, short  yPosVal);	
		
void  GetSymInfo (Byte *base, short *numVal ,			// all fields
							  short *varVal ,
							  short *fillVal,
							  short *rotVal ,
							  short *flopVal,
							  short *markVal,
							  short *xPosVal,
							  short *yPosVal);
							  		
void  SetSymInfo (Byte *base, short  numVal ,
							  short  varVal ,
							  short  fillVal,
							  short  rotVal ,
							  short  flopVal,
							  short  markVal,
							  short  xPosVal,
							  short  yPosVal);						  

					 
					 
		// Control code fields		
	   				  
	
typedef  enum { NewSign = 0, NewLine = 1, EOF = 2 };

// NOTE: Control codes are stored in a 2-bit field, 
//       and the text block code reserves value 3. 


void  NewCtrlCode (Byte *base);							// init control code

void  GetCtrlCode (Byte *base, short *codeVal);			// control code			  
void  SetCtrlCode (Byte *base, short  codeVal);			

void  GetCtrlLen  (Byte *base, short *lengthVal);		// sign length		  
void  SetCtrlLen  (Byte *base, short  lengthVal);	
		
		
		
		
		// Text block code fields		
		
// NOTE: NewTxtBlk assumes 5 bytes of space have been
//		 allocated: 3 for the text block code, and 2
//		 for an empty text string.  (Text block strings
//       are delimited by byte values of 255.)


void  NewTxtBlk (Byte *base);							// init text block

void  GetTxtXPos (Byte *base, short *posVal);			// text block X position	  
void  SetTxtXPos (Byte *base, short  posVal);	

void  GetTxtYPos (Byte *base, short *posVal);			// text block Y position			  
void  SetTxtYPos (Byte *base, short  posVal);		


